import sqlite3
import random

#connect to database:
conn = sqlite3.connect('/userdata/sqlite/sensor_data_1.db')
cursor = conn.cursor()

#create funtion used to geberate simulation data:
def generate_recommandations(num_entries):
	for i in range(num_entries):
		temperature = round(random.uniform(01.0, 40.0), 1)  #temperature between 1C and 40C
		humidity = round(random.uniform(20.0, 100.0), 1)     #humidity between 20% and 100%
		pressure = round(random.uniform(730, 790), 1)        #atmospheric pressure in mmHg
		uv_level = round(random.uniform(0, 11), 1)           #UV level between 0 and 11
		light = round(random.uniform(0, 1500), 1)            #light sensor - not used yet
		
		#generate recomandations based on temperature, humidity, pressure and uv_level
		if temperature > 35:
			recomandation = "Very hot. Drink water and avoid direct sun exposure!"
		elif temperature < 15 and humidity > 80:
			recommandation = "Cold and wet weather. Dress well and stay dry."
#		elif temperature > 28 and pressure < 750:
#			recommandation = "Possible precipitation. Go out with care."
		elif round((temperature - (100 - humidity)/5), 0) > temperature/2:
			recommandation = "Increased himidity. Rapid fogging of windows."
		elif temperature < 5 and humidity >= 50 and round((temperature - (100 - humidity)/5), 0) < 5:
			recommandation = "High risk of ice formation. Use appropiate footwear and clothes."	
		elif humidity < 30 and temperature > 30:
			recommandation = "Very dry air. Drink water often and use a himidifier."
		elif uv_level >= 8:
			recommandation = "High UV level. Use sunscreen!"
		elif uv_level >= 6 and pressure > 770 and temperature < 15:
			recommandation = "High UV level. Use cover for hand and face!"			
		elif pressure < 740:
			recommandation = "Unstable weather. Prepare for possible thunderstorms." 
		elif humidity > 90:
			recommandation = "Very high humidity. Be sure to stay hydrated."
		elif temperature >=20 and temperature <=30 and humidity <60:
			recommandation = "A perfect day for outdoor activities."
		elif light < 100:
			recommandation = "It is dark; take a flashlight with you."
		elif pressure >= 750 and pressure < 765:
			recommandation = "There are some clouds; you don't need a cap."
		elif uv_level >= 3 and uv_level < 8:
			recommandation = "Moderate UV level; definitely use something to cover"
		elif pressure > 770:
			recommandation = "It is a day without precipitation."
		elif round(float((temperature*1.8 + 32) - (0.55 - 0.0055*humidity) * ((temperature * 1.8 + 32)-58)), 0) >=80:
			recommandation = "Thermal comfort index exceeded; seek coolness and drink water!"
		elif round(float((temperature*1.8 + 32) - (0.55 - 0.0055*humidity) * ((temperature * 1.8 + 32)-58)), 0) < 65:
			recommandation = "Normal thermal comfort index"	
		elif round(float((temperature*1.8 + 32) - (0.55 - 0.0055*humidity) * ((temperature * 1.8 + 32)-58)), 0) >=65 and round(float((temperature*1.8 + 32) - (0.55 - 0.0055*humidity) * ((temperature * 1.8 + 32)-58)), 0) < 80:
			recommandation = "Thermal comfort index alert!"					
		else:
			recommandation = "A normal day. You can do various activities."  
	    
		#insert data in "recommandation" table:
		cursor.execute('''
			INSERT INTO recommandations (temperature, humidity, pressure, uv_level, light, recommandation)
			VALUES (?, ?, ?, ?, ?, ?)
		''', (temperature, humidity, pressure, uv_level, light, recommandation))
	
	#save modifications:
	conn.commit()
    
#generate 5000 records:
num_entries = 5000
generate_recommandations(num_entries)

#close connection with database:
conn.close()

print(f"{num_entries} data was gnerated and inserted in recommandations table.")
    
	    
	    
	    
